__precompile__(false)
module ExportToPostcard
using ..Ahorn, Maple, Gtk
export addons_menu
addons = GtkMenuItem("Addons")
addons_menu = GtkMenu(addons)
export_item = GtkMenuItem("Export to Postcard")
function compute_api_url(data, name)
    base64 = base64encode(data)
    startpath = "https://postcard.leo60228.space/start/"
    return "$startpath#$(basename(name)):$base64"
end
function open_long_url(url)
    path = "$(tempname()).html"
    write(path, """<meta http-equiv="refresh" content="0; URL='$(url)'" />""")
    if is_windows()
        run(`cmd /c start $path`)
    elseif is_linux()
        run(`xdg-open $path`)
    elseif is_apple()
        run(`open $path`)
    else
        run(`google-chrome-stable $path`)
    end
    @async begin
        sleep(20)
        rm(path)
    end
end
function export_to_postcard(item)
    Ahorn.saveFile(Ahorn.loadedState.side, Ahorn.loadedState.filename)
    filename = Ahorn.loadedState.filename
    fn = Ahorn.hasExt(filename, ".bin")? filename : filename * ".bin"
    url = compute_api_url(read(fn), fn)
    open_long_url(url)
end
push!(addons_menu, export_item)
signal_connect(export_to_postcard, export_item, :activate)
function add_addons_menu()
    println("Adding Addons to menubar")
    push!(Ahorn.menubar, addons)
    showall(Ahorn.window)
end
@async while true
    println("Polling Ahorn menubar status, currently $(Ahorn.menubar)")
    if Ahorn.menubar != nothing
        add_addons_menu()
        break
    end
    sleep(0.25)
end
end